Index: flashchips.c
===================================================================
--- flashchips.c	(revision 633)
+++ flashchips.c	(working copy)
@@ -58,7 +58,7 @@
 	{
 		.vendor		= "AMD",
 		.name		= "Am29F002(N)BB",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMD_ID,
 		.model_id	= AM_29F002BB,
 		.total_size	= 256,
@@ -74,7 +74,7 @@
 	{
 		.vendor		= "AMD",
 		.name		= "Am29F002(N)BT",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMD_ID,
 		.model_id	= AM_29F002BT,
 		.total_size	= 256,
@@ -90,7 +90,7 @@
 	{
 		.vendor		= "AMD",
 		.name		= "Am29F016D",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMD_ID,
 		.model_id	= AM_29F016D,
 		.total_size	= 2048,
@@ -106,7 +106,7 @@
 	{
 		.vendor		= "AMD",
 		.name		= "Am29F040B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMD_ID,
 		.model_id	= AM_29F040B,
 		.total_size	= 512,
@@ -122,7 +122,7 @@
 	{
 		.vendor		= "AMD",
 		.name		= "Am29F080B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMD_ID,
 		.model_id	= AM_29F080B,
 		.total_size	= 1024,
@@ -138,7 +138,7 @@
 	{
 		.vendor		= "AMD",
 		.name		= "Am29LV040B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMD_ID,
 		.model_id	= AM_29LV040B,
 		.total_size	= 512,
@@ -154,7 +154,7 @@
 	{
 		.vendor		= "AMD",
 		.name		= "Am29LV081B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMD_ID,
 		.model_id	= AM_29LV081B,
 		.total_size	= 1024,
@@ -170,7 +170,7 @@
 	{
 		.vendor		= "ASD",
 		.name		= "AE49F2008",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ASD_ID,
 		.model_id	= ASD_AE49F2008,
 		.total_size	= 256,
@@ -443,7 +443,7 @@
 	{
 		.vendor		= "Atmel",
 		.name		= "AT29C512",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ATMEL_ID,
 		.model_id	= AT_29C512,
 		.total_size	= 64,
@@ -716,7 +716,7 @@
 	{
 		.vendor		= "AMIC",
 		.name		= "A29002B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMIC_ID_NOPREFIX,
 		.model_id	= AMIC_A29002B,
 		.total_size	= 256,
@@ -732,7 +732,7 @@
 	{
 		.vendor		= "AMIC",
 		.name		= "A29002T",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= AMIC_ID_NOPREFIX,
 		.model_id	= AMIC_A29002T,
 		.total_size	= 256,
@@ -1084,7 +1084,7 @@
 	{
 		.vendor		= "Fujitsu",
 		.name		= "MBM29F004BC",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= FUJITSU_ID,
 		.model_id	= MBM29F004BC,
 		.total_size	= 512,
@@ -1100,7 +1100,7 @@
 	{
 		.vendor		= "Fujitsu",
 		.name		= "MBM29F004TC",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= FUJITSU_ID,
 		.model_id	= MBM29F004TC,
 		.total_size	= 512,
@@ -1116,7 +1116,7 @@
 	{
 		.vendor		= "Fujitsu",
 		.name		= "MBM29F400BC",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= FUJITSU_ID,
 		.model_id	= MBM29F400BC,
 		.total_size	= 512,
@@ -1132,7 +1132,7 @@
 	{
 		.vendor		= "Fujitsu",
 		.name		= "MBM29F400TC",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= FUJITSU_ID,
 		.model_id	= MBM29F400TC,
 		.total_size	= 512,
@@ -1388,7 +1388,7 @@
 	{
 		.vendor		= "Macronix",
 		.name		= "MX29F002B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= MX_ID,
 		.model_id	= MX_29F002B,
 		.total_size	= 256,
@@ -1404,7 +1404,7 @@
 	{
 		.vendor		= "Macronix",
 		.name		= "MX29F002T",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= MX_ID,
 		.model_id	= MX_29F002T,
 		.total_size	= 256,
@@ -1420,7 +1420,7 @@
 	{
 		.vendor		= "Macronix",
 		.name		= "MX29LV040C",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= MX_ID,
 		.model_id	= MX_29LV040C,
 		.total_size	= 512,
@@ -1644,7 +1644,7 @@
 	{
 		.vendor		= "PMC",
 		.name		= "Pm39LV010",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= PMC_ID_NOPREFIX,
 		.model_id	= PMC_39F010,
 		.total_size	= 128,
@@ -1660,7 +1660,7 @@
 	{
 		.vendor		= "PMC",
 		.name		= "Pm49FL002",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_LPC|CHIP_BUSTYPE_FWH, /* A/A Mux*/
 		.manufacture_id	= PMC_ID_NOPREFIX,
 		.model_id	= PMC_49FL002,
 		.total_size	= 256,
@@ -1676,7 +1676,7 @@
 	{
 		.vendor		= "PMC",
 		.name		= "Pm49FL004",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_LPC|CHIP_BUSTYPE_FWH, /* A/A Mux*/
 		.manufacture_id	= PMC_ID_NOPREFIX,
 		.model_id	= PMC_49FL004,
 		.total_size	= 512,
@@ -1692,7 +1692,7 @@
 	{
 		.vendor		= "Sharp",
 		.name		= "LHF00L04",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= SHARP_ID,
 		.model_id	= SHARP_LHF00L04,
 		.total_size	= 1024,
@@ -1820,7 +1820,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST28SF040A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_28SF040,
 		.total_size	= 512,
@@ -1836,7 +1836,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST29EE010",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_29EE010,
 		.total_size	= 128,
@@ -1852,7 +1852,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST29LE010",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_29LE010,
 		.total_size	= 128,
@@ -1868,7 +1868,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST29EE020A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_29EE020A,
 		.total_size	= 256,
@@ -1884,7 +1884,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST29LE020",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_29LE020,
 		.total_size	= 256,
@@ -1900,7 +1900,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39SF010A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39SF010,
 		.total_size	= 128,
@@ -1916,7 +1916,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39SF020A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39SF020,
 		.total_size	= 256,
@@ -1932,7 +1932,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39SF040",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39SF040,
 		.total_size	= 512,
@@ -1948,7 +1948,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39VF512",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39VF512,
 		.total_size	= 64,
@@ -1964,7 +1964,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39VF010",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39VF010,
 		.total_size	= 128,
@@ -1980,7 +1980,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39VF020",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39VF020,
 		.total_size	= 256,
@@ -1996,7 +1996,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39VF040",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39VF040,
 		.total_size	= 512,
@@ -2012,7 +2012,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST39VF080",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_39VF080,
 		.total_size	= 1024,
@@ -2028,7 +2028,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF002A/B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF002A,
 		.total_size	= 256,
@@ -2044,7 +2044,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF003A/B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF003A,
 		.total_size	= 384,
@@ -2060,7 +2060,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF004A/B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF004A,
 		.total_size	= 512,
@@ -2076,7 +2076,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF004C",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF004C,
 		.total_size	= 512,
@@ -2092,7 +2092,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF008A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF008A,
 		.total_size	= 1024,
@@ -2108,7 +2108,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF008C",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF008C,
 		.total_size	= 1024,
@@ -2124,7 +2124,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF016C",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF016C,
 		.total_size	= 2048,
@@ -2188,7 +2188,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF040B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_LPC, /* A/A Mux */
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF040B,
 		.total_size	= 512,
@@ -2204,9 +2204,9 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF080A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_LPC, /* A/A Mux */
 		.manufacture_id	= SST_ID,
-		.model_id	= SST_49LF080A,
+ 		.model_id	= SST_49LF080A,
 		.total_size	= 1024,
 		.page_size	= 4096,
 		.tested		= TEST_OK_PREW,
@@ -2220,7 +2220,7 @@
 	{
 		.vendor		= "SST",
 		.name		= "SST49LF160C",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_LPC,
 		.manufacture_id	= SST_ID,
 		.model_id	= SST_49LF160C,
 		.total_size	= 2048,
@@ -2396,7 +2396,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M29F002B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M29F002B,
 		.total_size	= 256,
@@ -2412,7 +2412,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M29F002T/NT",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M29F002T,
 		.total_size	= 256,
@@ -2428,7 +2428,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M29F040B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M29F040B,
 		.total_size	= 512,
@@ -2444,7 +2444,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M29F400BT",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M29F400BT,
 		.total_size	= 512,
@@ -2460,7 +2460,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M29W010B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M29W010B,
 		.total_size	= 128,
@@ -2476,7 +2476,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M29W040B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M29W040B,
 		.total_size	= 512,
@@ -2492,7 +2492,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FLW040A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH|CHIP_BUSTYPE_LPC, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FLW040A,
 		.total_size	= 512,
@@ -2508,7 +2508,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FLW040B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH|CHIP_BUSTYPE_LPC, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FLW040B,
 		.total_size	= 512,
@@ -2524,7 +2524,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FLW080A",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH|CHIP_BUSTYPE_LPC, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FLW080A,
 		.total_size	= 1024,
@@ -2540,7 +2540,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FLW080B",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH|CHIP_BUSTYPE_LPC, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FLW080B,
 		.total_size	= 1024,
@@ -2556,7 +2556,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FW002",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FW002,
 		.total_size	= 256,
@@ -2572,7 +2572,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FW016",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FW016,
 		.total_size	= 2048,
@@ -2588,7 +2588,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FW040",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FW040,
 		.total_size	= 512,
@@ -2604,7 +2604,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50FW080",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_FWH, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50FW080,
 		.total_size	= 1024,
@@ -2620,7 +2620,7 @@
 	{
 		.vendor		= "ST",
 		.name		= "M50LPW116",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_LPC, /* A/A Mux */
 		.manufacture_id	= ST_ID,
 		.model_id	= ST_M50LPW116,
 		.total_size	= 2048,
@@ -2636,7 +2636,7 @@
 	{
 		.vendor		= "SyncMOS",
 		.name		= "S29C31004T",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SYNCMOS_ID,
 		.model_id	= S29C31004T,
 		.total_size	= 512,
@@ -2652,7 +2652,7 @@
 	{
 		.vendor		= "SyncMOS",
 		.name		= "S29C51001T",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SYNCMOS_ID,
 		.model_id	= S29C51001T,
 		.total_size	= 128,
@@ -2668,7 +2668,7 @@
 	{
 		.vendor		= "SyncMOS",
 		.name		= "S29C51002T",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SYNCMOS_ID,
 		.model_id	= S29C51002T,
 		.total_size	= 256,
@@ -2684,7 +2684,7 @@
 	{
 		.vendor		= "SyncMOS",
 		.name		= "S29C51004T",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= SYNCMOS_ID,
 		.model_id	= S29C51004T,
 		.total_size	= 512,
@@ -2700,7 +2700,7 @@
 	{
 		.vendor		= "TI",
 		.name		= "TMS29F002RB",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= TI_OLD_ID,
 		.model_id	= TI_TMS29F002RB,
 		.total_size	= 256,
@@ -2716,7 +2716,7 @@
 	{
 		.vendor		= "TI",
 		.name		= "TMS29F002RT",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= TI_OLD_ID,
 		.model_id	= TI_TMS29F002RT,
 		.total_size	= 256,
@@ -2796,7 +2796,7 @@
 	{
 		.vendor		= "Winbond",
 		.name		= "W29C011",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= WINBOND_ID,
 		.model_id	= W_29C011,
 		.total_size	= 128,
@@ -2844,7 +2844,7 @@
 	{
 		.vendor		= "Winbond",
 		.name		= "W29EE011",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= WINBOND_ID,
 		.model_id	= W_29C011,
 		.total_size	= 128,
@@ -2940,7 +2940,7 @@
 	{
 		.vendor		= "Winbond",
 		.name		= "W49F002U",
-		.bustype	= CHIP_BUSTYPE_NONSPI,
+		.bustype	= CHIP_BUSTYPE_PARALLEL,
 		.manufacture_id	= WINBOND_ID,
 		.model_id	= W_49F002U,
 		.total_size	= 256,